from emtest import EmTest
import time


class TestI2C(EmTest):
    def setup_class(self):
        self.week_branch = "Week_07"
        self.replacements = []
        super().setup_class(self)

    def test_gpio_interrupts_used(self):
        self.session.target.halt()
        assert self.interrupts.gpio.has_any_interrupt_set()

    def test_nothing_printed(self):
        time.sleep(2)
        data_ready = self.serial.in_waiting
        time.sleep(30)
        assert self.serial.in_waiting == data_ready

    def test_servo_orientation(self):
        time.sleep(5)
        self.serial.flushInput()
        assert self.serial.in_waiting == 0
        self.servo.set_servo_angle(0)
        time.sleep(10)
        assert self.serial.in_waiting != 0
        previous_serial = self.serial.in_waiting
        self.servo.set_servo_angle(90)
        time.sleep(5)
        assert self.serial.in_waiting != previous_serial
