from emtest import EmTest
import time
import vtable_constants


class TestInterrupt(EmTest):
    def setup_class(self):
        self.week_branch = "Week_03"
        super().setup_class(self)

    def test_nothing_printed_on_idle(self):
        self.buttons.sw3.off()
        time.sleep(5)
        data = self.serial.read(self.serial.in_waiting)
        assert len(data) == 0

    def test_full_press(self):
        self.buttons.sw3.off()
        time.sleep(1)
        self.buttons.sw3.on()
        time.sleep(1)
        data = self.serial.read(self.serial.in_waiting)
        assert len(data) != 0

    def test_pulse(self):
        self.buttons.sw3.off()
        time.sleep(1)
        self.buttons.sw3.pulse()
        time.sleep(0.5)
        data = self.serial.read(self.serial.in_waiting)
        assert len(data) == 0

    def test_interrupts_used(self):
        self.session.target.halt()
        assert self.interrupts.pit.has_any_interrupt_set()
        assert self.interrupts.gpio.interrupt_not_default(vtable_constants.PORT_A_VECTOR)
